package ch.frankel.blog.wsinject.impl;

import java.util.GregorianCalendar;

import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;

import ch.frankel.blog.wsinject.domain.Person;
import ch.frankel.blog.wsinject.jaxws.FindPersonRequestType;
import ch.frankel.blog.wsinject.jaxws.FindPersonResponseType;
import ch.frankel.blog.wsinject.jaxws.ObjectFactory;
import ch.frankel.blog.wsinject.jaxws.PersonType;
import ch.frankel.blog.wsinject.service.PersonService;

class FindPersonDelegate {

	public FindPersonResponseType findPerson(PersonService personService,
			FindPersonRequestType parameters) {

		Long id = parameters.getId();

		ObjectFactory factory = new ObjectFactory();

		FindPersonResponseType response = factory.createFindPersonResponseType();

		Person person = personService.findByKey(id);

		PersonType type = factory.createPersonType();

		response.setPerson(type);

		type.setId(person.getId());
		type.setFirstName(person.getFirstName());
		type.setLastName(person.getLastName());

		try {

			GregorianCalendar calendar = new GregorianCalendar();
			
			calendar.setTime(person.getBirthdate());
			
			type.setBirthdate(DatatypeFactory.newInstance().newXMLGregorianCalendar(calendar));
			
			return response;

		} catch (DatatypeConfigurationException e) {

			throw new RuntimeException(e);
		}
	}
}
