package ch.frankel.blog.wsinject.impl;

import org.springframework.ws.server.endpoint.annotation.Endpoint;
import org.springframework.ws.server.endpoint.annotation.PayloadRoot;
import org.springframework.ws.server.endpoint.annotation.RequestPayload;
import org.springframework.ws.server.endpoint.annotation.ResponsePayload;

import ch.frankel.blog.wsinject.jaxws.FindPersonRequestType;
import ch.frankel.blog.wsinject.jaxws.FindPersonResponseType;
import ch.frankel.blog.wsinject.service.PersonService;

@Endpoint
public class FindPersonServiceEndpoint {

	private final PersonService personService;

	public FindPersonServiceEndpoint(PersonService personService) {

		this.personService = personService;
	}

	@PayloadRoot(localPart = "findPersonRequestType", namespace = "http://blog.frankel.ch/ws-inject")
	@ResponsePayload
	public FindPersonResponseType findPerson(@RequestPayload FindPersonRequestType parameters) {

		return new FindPersonDelegate().findPerson(personService, parameters);
	}
}
